CREATE TABLE categories (id BIGINT UNIQUE, name VARCHAR(255) NOT NULL, display VARCHAR(255) NOT NULL, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE comments (id BIGINT UNIQUE, post BIGINT NOT NULL, writer BIGINT NOT NULL, title VARCHAR(255) NOT NULL, content TEXT NOT NULL, reply BIGINT NOT NULL, status VARCHAR(255) NOT NULL, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, INDEX post_idx (post), INDEX writer_idx (writer), PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE menu_items (id BIGINT UNIQUE, menu BIGINT NOT NULL, caption VARCHAR(255) NOT NULL, position BIGINT NOT NULL, rank BIGINT NOT NULL, url VARCHAR(255) NOT NULL, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, INDEX menu_idx (menu), INDEX rank_idx (rank), PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE menus (id BIGINT UNIQUE, name VARCHAR(255) NOT NULL, position BIGINT NOT NULL, url VARCHAR(255) NOT NULL, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE posts (id BIGINT UNIQUE, title VARCHAR(255), content TEXT NOT NULL, writer BIGINT NOT NULL, category BIGINT NOT NULL, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, comment VARCHAR(255) NOT NULL, tags VARCHAR(255) NOT NULL, name VARCHAR(255) NOT NULL, type VARCHAR(255) NOT NULL, INDEX writer_idx (writer), INDEX category_idx (category), PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE ranks (id BIGINT UNIQUE, name VARCHAR(255) NOT NULL, display VARCHAR(255) NOT NULL, value BIGINT NOT NULL, color VARCHAR(255) NOT NULL, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE settings (`option` VARCHAR(255) UNIQUE, `value` VARCHAR(255) NOT NULL, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, PRIMARY KEY(`option`)) ENGINE = INNODB;
CREATE TABLE sites (id BIGINT UNIQUE, sitename BIGINT NOT NULL, writer BIGINT NOT NULL, title VARCHAR(255) NOT NULL, content TEXT NOT NULL, status VARCHAR(255) NOT NULL, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, INDEX writer_idx (writer), PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE users (id BIGINT UNIQUE, username VARCHAR(255) NOT NULL, displayname VARCHAR(255) NOT NULL, password VARCHAR(255) NOT NULL, email VARCHAR(255) NOT NULL, registered_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, rank BIGINT NOT NULL, created_at DATETIME NOT NULL, INDEX rank_idx (rank), PRIMARY KEY(id)) ENGINE = INNODB;
ALTER TABLE comments ADD CONSTRAINT comments_writer_users_id FOREIGN KEY (writer) REFERENCES users(id) ON DELETE CASCADE;
ALTER TABLE comments ADD CONSTRAINT comments_post_posts_id FOREIGN KEY (post) REFERENCES posts(id) ON DELETE CASCADE;
ALTER TABLE menu_items ADD CONSTRAINT menu_items_rank_ranks_id FOREIGN KEY (rank) REFERENCES ranks(id) ON DELETE CASCADE;
ALTER TABLE menu_items ADD CONSTRAINT menu_items_menu_menus_id FOREIGN KEY (menu) REFERENCES menus(id) ON DELETE CASCADE;
ALTER TABLE posts ADD CONSTRAINT posts_writer_users_id FOREIGN KEY (writer) REFERENCES users(id) ON DELETE CASCADE;
ALTER TABLE posts ADD CONSTRAINT posts_category_categories_id FOREIGN KEY (category) REFERENCES categories(id) ON DELETE CASCADE;
ALTER TABLE sites ADD CONSTRAINT sites_writer_users_id FOREIGN KEY (writer) REFERENCES users(id) ON DELETE CASCADE;
ALTER TABLE users ADD CONSTRAINT users_rank_ranks_id FOREIGN KEY (rank) REFERENCES ranks(id) ON DELETE CASCADE;
